require "class"
require "goodslist"
local inventory = require("components/veminventory")
local InvSlot = require "widgets/veminvslot"
local TileBG = require "widgets/tilebg"
local Image = require "widgets/image"
local Widget = require "widgets/widget"
local ItemTile = require "widgets/vemitemtile"
local Text = require "widgets/text"
local AnimButton = require "widgets/animbutton"
local TextButton = require "widgets/textbutton"
local ImageButton = require "widgets/imagebutton"

local HUD_ATLAS = "images/hud.xml"
local NUM_COLUMS = 4
local MAX_ROWS = 5
local MAXSLOTS = NUM_COLUMS * MAX_ROWS

PAGE_PRICE = 2
NUMSLOT = {}
PRICE_float = {1,1,1,5,10}
VEM_random = true
sellItems1 = {}
sellItems2 = {}
sellItems3 = {}
sellItems4 = {}
sellItems5 = {}

local Inv = Class(Widget, function(self, owner)
	Widget._ctor(self, "Inventory")
	
	self.slots = self:AddChild(Widget("SLOTS"))
	self.inventory = {}
	self.maxpages = 0
	self.currentpage = 0
    self.owner = owner
	self.base_scale = .9
	self.selected_scale = 1.1
    self:SetScale(self.base_scale)
	PAGE_PRICE = 2
    
    if self.inv then
	    for k,v in pairs(self.inv) do
			v:SetTile(nil)
		end
	end

    self.inv = {}
    
    local strItems1 = {}
	local strItems2 = {}
	local strItems3 = {}
	local strItems4 = {}
	local strItems5 = {}
    
    for k,v in pairs(ITEMLIST1) do 
    	--if not contains(strItems1, v) and not string.find(v, "blueprint") then
    		table.insert(strItems1, v)
    	--end
    end
    
	for k,v in pairs(ITEMLIST2) do 
    	--if not contains(strItems2, v) and not string.find(v, "blueprint") then
    		table.insert(strItems2, v)
    	--end
    end
	
	for k,v in pairs(ITEMLIST3) do 
    	--if not contains(strItems3, v) and not string.find(v, "blueprint") then
    		table.insert(strItems3, v)
    	--end
    end
	
	for k,v in pairs(ITEMLIST4) do 
    	--if not contains(strItems4, v) and not string.find(v, "blueprint") then
    		table.insert(strItems4, v)
    	--end
    end
	
	for k,v in pairs(ITEMLIST5) do 
    	--if not contains(strItems5, v) and not string.find(v, "blueprint") then
    		table.insert(strItems5, v)
    	--end
    end
	
	if VEM_random then  --价格浮动
		PRICE_float[0] =  math.random(0,1)
		if PRICE_float[0] == 0 then
		   PRICE_float[0] =  math.random(0,1)
		end
		PRICE_float[1] =  math.random(0,2)
		if PRICE_float[1] == 0 then
		   PRICE_float[1] =  math.random(0,2)
		end
		PRICE_float[2] =  math.random(0,8)
		if PRICE_float[2] < 4 then
		   PRICE_float[2] =  math.random(0,8)
		end
		PRICE_float[3] =  math.random(0,20)
		if PRICE_float[3] < 10 then
		   PRICE_float[3] =  math.random(0,20)
		end
		PRICE_float[4] =  math.random(0,30)
		if PRICE_float[4] < 10 then
		   PRICE_float[4] =  math.random(0,30)
		end
	end
	
	if VEM_random or not sellItems1 or not sellItems2 or not sellItems3 or not sellItems4 or not sellItems5  then
		local n = #strItems1 - 1
		for k = 0, n do   --商品乱序
			local m = math.random(#strItems1)
			local mx = strItems1[m]
			table.remove(strItems1, m)
			sellItems1[k] = mx
		end
	
		local n = #strItems2 - 1
		for k = 0, n do   --商品乱序
			local m = math.random(#strItems2)
			local mx = strItems2[m]
			table.remove(strItems2, m)
			sellItems2[k] = mx
		end
	
		local n = #strItems3 - 1
		for k = 0, n do   --商品乱序
			local m = math.random(#strItems3)
			local mx = strItems3[m]
			table.remove(strItems3, m)
			sellItems3[k] = mx
		end
		
		local n = #strItems4 - 1
		for k = 0, n do   --商品乱序
			local m = math.random(#strItems4)
			local mx = strItems4[m]
			table.remove(strItems4, m)
			sellItems4[k] = mx
		end
		
		local n = #strItems5 - 1
		for k = 0, n do   --商品乱序
			local m = math.random(#strItems5)
			local mx = strItems5[m]
			table.remove(strItems5, m)
			sellItems5[k] = mx
		end
		
		VEM_random = false
	end
	
	NUMSLOT[0] = 15	
	NUMSLOT[1] = 15
	NUMSLOT[2] = 11
	NUMSLOT[3] = 7
	NUMSLOT[4] = 5
    local i = 0
	for k,v in pairs(sellItems1) do
		if k < 20 then
			local item = SpawnPrefab(v)
			if item ~= nil then
				if item.components and item.components.inventoryitem then
					self.inventory[i] = item
					i = i + 1
				else
					item:Remove()
				end
			end
		end
    end
    local i = 20
	for k,v in pairs(sellItems2) do
		if k < 20 then
			local item = SpawnPrefab(v)
			if item ~= nil then
				if item.components and item.components.inventoryitem then
					self.inventory[i] = item
					i = i + 1
				else
					item:Remove()
				end
			end
		end
    end
	local i = 40
	for k,v in pairs(sellItems3) do
		if k < 20 then
			local item = SpawnPrefab(v)
			if item ~= nil then
				if item.components and item.components.inventoryitem then
					self.inventory[i] = item
					i = i + 1
				else
					item:Remove()
				end
			end
		end
    end
    local i = 60
	for k,v in pairs(sellItems4) do
		if k < 20 then
			local item = SpawnPrefab(v)
			if item ~= nil then
				if item.components and item.components.inventoryitem then
					self.inventory[i] = item
					i = i + 1
				else
					item:Remove()
				end
			end
		end
    end
    local i = 80
	for k,v in pairs(sellItems5) do
		if k < 20 then
			local item = SpawnPrefab(v)
			if item ~= nil then
				if item.components and item.components.inventoryitem then
					self.inventory[i] = item
					i = i + 1
				else
					item:Remove()
				end
			end
		end
    end
	
    --table.sort(self.inventory, function(a,b) return a:GetDisplayName() < b:GetDisplayName() end)
    
    self.menu = self:AddChild(Widget("MENU"))
	self.menu:SetPosition(225, -0, 0)

	self.buttonone = self.menu:AddChild(ImageButton())
	self.buttonone:SetText("I")
	self.buttonone:SetScale(.7,.7,.7)
    self.buttonone:SetPosition(-(117+75), -370, 0)
    self.buttonone:SetOnClick( function() self:TurntoPage(0) end)
	
	self.buttontwo = self.menu:AddChild(ImageButton())
	self.buttontwo:SetText("II")
	self.buttontwo:SetScale(.7,.7,.7)
    self.buttontwo:SetPosition(-(75), -370, 0)
    self.buttontwo:SetOnClick( function() self:TurntoPage(1) end)
	
	self.buttonthree = self.menu:AddChild(ImageButton())
	self.buttonthree:SetText("III")
	self.buttonthree:SetScale(.7,.7,.7)
    self.buttonthree:SetPosition((117-75), -370, 0)
    self.buttonthree:SetOnClick( function() self:TurntoPage(2) end)
	
	self.buttonfour = self.menu:AddChild(ImageButton())
	self.buttonfour:SetText("IV")
	self.buttonfour:SetScale(.7,.7,.7)
    self.buttonfour:SetPosition(-(117+75), -420, 0)
    self.buttonfour:SetOnClick( function() self:TurntoPage(3) end)
	
	self.buttonfive = self.menu:AddChild(ImageButton())
	self.buttonfive:SetText("V")
	self.buttonfive:SetScale(.7,.7,.7)
    self.buttonfive:SetPosition((-75), -420, 0)
    self.buttonfive:SetOnClick( function() self:TurntoPage(4) end)
    
    self.pagetext = self.menu:AddChild(Text(DEFAULTFONT, 60))
    self.pagetext:SetString("1g for each")--初始文本
	self.pagetext:SetScale(.7,.7,.7)
    self.pagetext:SetColour(1,1,1,1)
	self.pagetext:SetPosition(-75, -460, 0)
	
	self.needDT = self.menu:AddChild(Text(DEFAULTFONT, 60))
	self.needDT:SetString("cost 1 demon ticket")
	self.needDT:SetScale(.7,.7,.7)
    self.needDT:SetColour(1,1,1,1)
	self.needDT:SetPosition(-75, -320, 0)
	self.needDT:Hide()

	self.rebuild_pending = true
	
end)

function Inv:Rebuild()

	local page = self.currentpage
	self.slots:KillAllChildren()

    for k,v in pairs(self.inv) do
    	v:Kill()
    end

    self.inv = {}

    self.maxpages = 4--最大页数减一
    
    --if self.maxpages <= 0 then
    	--self.nextbutton:Hide()
    --end
    
    
    local W = 76
    local H = 76
    local maxwidth = (W * NUM_COLUMS)
	
	local positions = 0
    for k = 0, 15 do
    	local kp = k + (page * 20)
		if self.inventory[kp] and k <= NUMSLOT[page] then
			local height = math.floor(positions / NUM_COLUMS) * H
			local slot = InvSlot(kp, HUD_ATLAS, "inv_slot.tex", self.owner, self.inventory)
			self.inv[kp] = self.slots:AddChild(slot)
			self.inv[kp]:SetTile(ItemTile(self.inventory[kp]))
			
			local remainder = positions % NUM_COLUMS
			local row = math.floor(positions / NUM_COLUMS) * H +30 --Y位移

			local x = W * remainder + 35 --X位移
			slot:SetPosition(x,-row,0)
			positions = positions + 1
		end
    end

	self.rebuild_pending = false
	
	if self.currentpage == 0 then PAGE_PRICE = 2 + PRICE_float[0] end
	if self.currentpage == 1 then PAGE_PRICE = 6 + PRICE_float[1] end
	if self.currentpage == 2 then PAGE_PRICE = 12 + PRICE_float[2] end
	if self.currentpage == 3 then PAGE_PRICE = 35 + PRICE_float[3] end
	if self.currentpage == 4 then 
		PAGE_PRICE = 80 + PRICE_float[4] 
		self.needDT:Show()
	else
		self.needDT:Hide()
	end
    self.pagetext:SetString((PAGE_PRICE).."coins for each")
end


function Inv:Update(dt)

	if self.rebuild_pending == true then
		self:Rebuild()
		--self:Refresh()
	end
end

function Inv:OnControl(control, down)
	if Inv._base.OnControl(self, control, down) then return true end
	
	if self.open then
		if not down then 
			if control == CONTROL_ACCEPT then
				self.inv[self.active_slot]:Click()
			end
		end
	end
end

function Inv:Refresh()
	
	for k,v in pairs(self.inv) do
		v:SetTile(nil)
	end

	for k,v in pairs(self.inventory) do
		if v then
			local tile = ItemTile(v, self)
			if (self.inv[k]) then
				self.inv[k]:SetTile(tile)
			end
		end
	end
end

function Inv:Delete()
	for k,v in pairs(self.inventory) do
    	v:Remove()
    end
	for k,v in pairs(self.inv) do
    	v:Kill()
    end
end

function contains(tab,val)
	for k,v in pairs(tab) do 
		if v == val then 
			return true 
		end
	end

	return false
end
--[[
function Inv:Scroll(dir)

	local tempcurrentpage = self.currentpage
	
	self.currentpage = self.currentpage + dir
	
	if self.currentpage <= 0 then
		self.currentpage = 0
		self.prevbutton:Hide()
	else
		self.prevbutton:Show()
	end
	
	if self.currentpage >= self.maxpages then
		self.currentpage = self.maxpages
		self.nextbutton:Hide()
	else
		self.nextbutton:Show()
	end
	
	if tempcurrentpage ~= self.currentpage then
		for k,v in pairs(self.inv) do
	    	v:Kill()
	    end
		
		self.rebuild_pending = true
	end
	
end
--]]
function Inv:TurntoPage(topage)
	self.currentpage = topage
	for k,v in pairs(self.inv) do
	    v:Kill()
	end
	self.rebuild_pending = true
end
return Inv